///////////////////////////////////////////////////
//Project 3.05 LED Chase II
int LEDS[4] = {
  6,7,8,13};
int isPress = HIGH;
int SW1 = A2;
int wait = 60;
int potentiometer = A0;
int potRead = 0;
int steps = 1;
int thisLED = 0;
long now = 0;
long lastPressed = 0;
void setup(){
  for(int k = 0; k < 4; k++){
    pinMode(LEDS[k],OUTPUT);
  }
  pinMode(potentiometer,INPUT);
  pinMode(SW1,INPUT);
}
void loop(){
  isPress = digitalRead(SW1);
  potRead = analogRead(potentiometer)/4;
  if(millis() > now + potRead){
    digitalWrite(LEDS[thisLED],LOW);
    thisLED = thisLED + steps;
    if(thisLED < 0) thisLED = 3;
    if(thisLED > 3) thisLED = 0;
    digitalWrite(LEDS[thisLED],HIGH);
    now = millis();
  }
  if(isPress==LOW && millis() > lastPressed + 1000){
    steps = steps*-1;
    lastPressed = millis();
  }
}
///////////////////////////////////////////////////
