///////////////////////////////////////////////////
//Project 4.05 Piezo Metronome I
int piezo = 12;
int knock = 0;
int redLED = 9;
int periods = 0;
int wait = 0;
int nchar = 0;
void setup(){
  Serial.begin(9600);
  pinMode(piezo,OUTPUT);
  pinMode(redLED,OUTPUT);
}
void loop(){
  //wait for serial input
  while(Serial.available()==0){
  } 
  delay(50);
  if(Serial.available()>0){
    nchar = Serial.available();
    char readIn[nchar +1];
    for(int k = 0; k < nchar; k++){
      readIn[k] = Serial.read();
    }
    periods = atoi(readIn); 
  }
  if(periods > 1200 || periods < 1){
    Serial.println(Period outside range, period set to 1200);
    periods = 1200;
  }
  Serial.print(Beats per Minute = );
  Serial.println(periods); 
  while(Serial.available()==0){    
    //create tone
    digitalWrite(redLED,HIGH);
    piezoTone(2500,50);
    digitalWrite(redLED,LOW);
    wait = 60000/periods;
    wait = wait-50;
    delay(wait);
  } //end if serial not available
}
void piezoTone(long freq, long duration){
  long aSecond = 1000000;
  long period = aSecond/freq;
  duration = duration*1000;
  duration = duration/period;
  for(long k = 0; k < duration; k++){
    digitalWrite(piezo,HIGH);
    delayMicroseconds(period/2);
    digitalWrite(piezo,LOW);
    delayMicroseconds(period/2);
  }
} 
///////////////////////////////////////////////////
