///////////////////////////////////////////////////
//Project 6.04 High Temperature Alarm
int tempreg = 0;         
float temperature = 0;     
byte address = 72;
int piezo = 12;
float tooHot = 32.2;
//Do some setup for the sensor 
void setup(){ 
  pinMode(piezo,OUTPUT);
  Serial.begin(9600);
  setupSensor(); 
} 
void loop(){
  Serial.print(TEMP = );
  Serial.println(getTemp(),1);
  if(getTemp() > tooHot) piezoTone(4000,10); 
}
//intialize the sensor
void setupSensor(){
  Wire.begin();
  Wire.beginTransmission(address);
  Wire.write(0x01);     
  Wire.write(0x60);     
  Wire.endTransmission();        
  Wire.beginTransmission(address);  
  Wire.write( byte(0x00)),            
  Wire.endTransmission();         
}  
//Query the sensor and return the temperature
float getTemp(){
  Wire.requestFrom(address, byte(2)); 
  tempreg = Wire.read();       
  tempreg= tempreg << 8;      
  tempreg |= Wire.read();   
  tempreg = tempreg >> 4;  
  temperature =( float ) tempreg / 16;
  return temperature;
}
//Sound the alarm!!
void piezoTone(long freq, long duration){
  long aSecond = 1000000;
  long period = aSecond/freq;
  duration = duration*1000;
  duration = duration/period;
  for(long k = 0; k < duration; k++){
    digitalWrite(piezo,HIGH);
    delayMicroseconds(period/2);
    digitalWrite(piezo,LOW);
    delayMicroseconds(period/2);
  }
} 
///////////////////////////////////////////////////
